freeslot("S_RKYKIKD", "S_KIKDEAD", "MT_RKYKICKEDENEMY", "MT_RKYPUNCHEDENEMY", "MT_RKYKICKEDEXTRA", "MT_RKYKICKEDPOOF", "sfx_rkrng", "sfx_rkgmd", "SPR_RKSN", "sfx_641up", "sfx_64brk")
sfxinfo[sfx_rkrng].flags = $|SF_X2AWAYSOUND
// kick deaths, done similarly to SM64


// I had to BLUA a goddamn SM64 function lord alMIGHTY

states[S_RKYKIKD] = {SPR_NULL, 0, -1, A_FlickySpawn, 0, 0, S_RKYKIKD}
states[S_KIKDEAD] = {SPR_BOM1, 0, 2, nil, 1<<17, 0, S_XPLD1}

mobjinfo[MT_RKYKICKEDENEMY] = {
	doomednum = -1,
	spawnstate = S_RKYKIKD,
	spawnhealth = 1000,
	radius = 20*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_NOCLIPTHING
}
mobjinfo[MT_RKYPUNCHEDENEMY] = {
	doomednum = -1,
	spawnstate = S_RKYKIKD,
	spawnhealth = 1000,
	radius = 20*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_NOCLIPTHING
}
mobjinfo[MT_RKYKICKEDEXTRA] = {
	doomednum = -1,
	spawnstate = S_RKYKIKD,
	spawnhealth = 1000,
	radius = 20*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}
mobjinfo[MT_RKYKICKEDPOOF] = {
	doomednum = -1,
	spawnstate = S_KIKDEAD,
	spawnhealth = 1000,
	radius = 20*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_NOGRAVITY
}
/*
-1,             // doomednum
		S_RING,         // spawnstate
		1000,           // spawnhealth
		S_NULL,         // seestate
		sfx_None,       // seesound
		MT_FLINGRING,   // reactiontime
		sfx_None,       // attacksound
		S_NULL,         // painstate
		MT_RING,        // painchance
		sfx_None,       // painsound
		S_NULL,         // meleestate
		S_NULL,         // missilestate
		S_SPRK1,        // deathstate
		S_NULL,         // xdeathstate
		sfx_itemup,     // deathsound
		38*FRACUNIT,    // speed
		15*FRACUNIT,    // radius
		24*FRACUNIT,    // height
		0,              // display offset
		100,            // mass
		0,              // damage
		sfx_None,       // activesound
		MF_SLIDEME|MF_SPECIAL, // flags
		S_NULL          // raisestate

*/
mobjinfo[MT_RKYPOOFRING] = {
	doomednum = -1,
	spawnstate = S_RKYCOIN,
	spawnhealth = 1000,
	deathsound = sfx_64con,
	deathstate = S_SPRK1,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = 100,
	flags = MF_SLIDEME|MF_SPECIAL,
	reactiontime = MT_FLINGRING,
	painchance = MT_RING,
	speed = 38*FRACUNIT
}

local function doPunchEffect(actor, angle)
	for i=1,8
		local star = P_SpawnMobj(actor.x, actor.y, actor.z, MT_GPSTAR);
		local xDist = 9*cos(45*(i*ANG1));
		local x1 = (xDist/actor.scale)*cos(angle-(90*ANG1))
		local y1 = (xDist/actor.scale)*sin(angle-(90*ANG1))
		star.momx = x1;
		star.momy = y1;
		star.momz = 9*sin(45*(i*ANG1));
		star.scale = (((actor.scale)*155)/1000);
		//P_SetScale(star, (((actor.scale)*15)/1000));
	end
end

local function bounceBackFromAttack(p)
    local playerstate = p.mo.state;
    local mo = p.mo;
	local enemyLaunchMom = 0;
    if ((playerstate == S_PLAY_KICK) or (playerstate == S_PLAY_KCST))
        if (p.kickType == 1)
            //mario_set_forward_vel(m, -16.0f);
	    p.mo.momx = -8*cos(p.drawangle);
	    p.mo.momy = -8*sin(p.drawangle);
		enemyLaunchMom = 16;
		p.drawangle = (InvAngle(p.drawangle));
        else
            //mario_set_forward_vel(m, -48.0f); too strong for SRB2 standards
	    p.mo.momx = -24*cos(p.drawangle);
	    p.mo.momy = -24*sin(p.drawangle);
		enemyLaunchMom = 48;
		p.drawangle = (InvAngle(p.drawangle));
        end

        //set_camera_shake_from_hit(SHAKE_ATTACK); -- going to just do a quake
		P_StartQuake(FRACUNIT*3, 10);
        //m->particleFlags |= PARTICLE_TRIANGLE; -- damage particle
		P_AddPlayerScore(p, 2000);
		S_StartSound(p.mo, sfx_sgiwk);
    end
end

local function bouncePlayerBackFromAttack(p)
    local playerstate = p.mo.state;
    local mo = p.mo;
    if ((playerstate == S_PLAY_KICK) or (playerstate == S_PLAY_KCST))
        if (p.kickType == 1)
			p.hitTimer = 10;
			p.hitAngle = p.drawangle;
			p.mo.momx = -8*cos(p.drawangle);
			p.mo.momy = -8*sin(p.drawangle);
			//p.drawangle = (InvAngle(p.mo.angle));
        else
			p.hitTimer = 10;
			p.hitAngle = p.drawangle;
			p.mo.momx = -24*cos(p.drawangle);
			p.mo.momy = -24*sin(p.drawangle);
			//p.drawangle = (InvAngle(p.mo.angle));
        end
		
		P_StartQuake(FRACUNIT*3, 10);
		S_StartSound(p.mo, sfx_sgiwk);
    elseif (p.punchTimer > 0)
			p.hitTimer = 10;
			p.hitAngle = p.drawangle;
			p.mo.momx = -8*cos(p.drawangle);
			p.mo.momy = -8*sin(p.drawangle);
			doPunchEffect(p.mo, p.drawangle);
		S_StartSound(p.mo, sfx_sgiwk);
	end
end

local function doCorkExplosion(actor)
	local rand;
	for i=1,25
		local cork = P_SpawnMobj(actor.x, actor.y, actor.z, MT_WOODDEBRIS)
		rand = (P_RandomRange(0, 359) * FRACUNIT);
		cork.momx = 15*cos(FixedAngle(rand));
		cork.momy = 15*sin(FixedAngle(rand));
		cork.momz = ((rand % 22) * FRACUNIT);
		P_SetScale(cork, (((actor.scale)*150)/100));
	end
	for i=1,25
		local dust = P_SpawnMobj(actor.x, actor.y, actor.z, MT_SPINDUST);
		rand = (P_RandomRange(0, 359) * FRACUNIT);
		dust.momx = 45*cos(FixedAngle(rand));
		dust.momy = 45*sin(FixedAngle(rand));
		dust.momz = ((rand % 22) * FRACUNIT);
		P_SetScale(dust, (((actor.scale)*350)/100))
		dust.destscale = (((actor.scale)*0)/100);
	end
end

local function isBattleMod()
	local var  = false
	if ((gametype == GT_ARENA) or (gametype == GT_SURVIVAL) or (gametype == GT_DIAMOND) or (gametype == GT_BATTLECTF))
		var = true;
	end
	return var
end

local function doKickStars(actor)
	
	local rainbowTable = {SKINCOLOR_RED, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW, SKINCOLOR_EMERALD, SKINCOLOR_SKY, SKINCOLOR_DUSK, SKINCOLOR_NEON}
	for i = 0, 6
		local star = P_SpawnMobj(actor.x, actor.y, actor.z, MT_GPSTAR);
		local rngAngle = P_RandomRange(0,360);
		local rngHeight = P_RandomRange(0,15);
		local rngColor = P_RandomKey(7)+1
		star.color = rainbowTable[rngColor]
		star.scale = (((actor.scale)*555)/1000);
		star.colorized = true;
		star.angle = rngAngle;
		star.momx = 7*cos(rngAngle*ANG1);
		star.momy = 7*sin(rngAngle*ANG1);
		star.momz = rngHeight*FRACUNIT;
	end
	
	
end

addHook("MobjThinker", function(mo)
	if (P_IsObjectOnGround(mo))
	or ((mo.deathTimeout ~= nil) and (mo.deathTimeout <= 0))
		//local objType = mobjinfo[MT_FLINGRING].reactiontime;
		local poofRing = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RKYPOOFRING)
		poofRing.momz = 12*poofRing.scale;
		poofRing.zMomLog = 0;
		poofRing.shadowscale = 2*FRACUNIT/3;
		//poofRing.flags = (poofRing.flags & ~MF_NOGRAVITY);
		local poof = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RKYKICKEDPOOF)
		poof.scale = mo.scale;
		mo.momx = 0;
		mo.momy = 0;
		mo.flags = $|MF_NOGRAVITY;
		if mo.wasGoomba == nil
			S_StartSound(poof, sfx_pop);
		else
			S_StartSound(poof, sfx_rkgmd);
		end
		if (mo.valid)
		and (mo.state ~= S_NULL)
			mo.state = S_NULL;
		end
	end
		
	if (mo.valid) 
	and (mo.deathTimeout ~= nil)
		if (mo.kickedFx ~= nil)
		and (mo.kickedFx == true)
			mo.rollangle = $1 + ((110*65536)*30)
			mo.angle = $1 + ((1300*ANG1)/10)
			if (mo.spritexscale < 1<<16)
				mo.spritexscale = $1 + ((277<<16)/10000)
				mo.spriteyscale = $1 - ((833<<16)/10000)
			end
		end
		mo.deathTimeout = $1 - 1;
	end
end, MT_RKYKICKEDENEMY)

addHook("MobjThinker", function(mo)
	mo.rollangle = $1 + ((225*ANG1)/100);
end, MT_RKYKICKEDEXTRA)

addHook("MobjCollide", function(mo, tm)
	if (tm.player) 
	and ((mo.z >= (tm.z - (60*mo.scale))) and (mo.z <= (tm.z + (80*mo.scale))))
		P_GivePlayerRings(tm.player, 1)
		mo.momz = 0;
		mo.momx = 0;
		mo.momy = 0;
		mo.shadowscale = 0;
		S_StartSound(mo,sfx_64con); -- Has to be here otherwise no sound will play when picking it up.
		P_KillMobj(mo);
	end
end, MT_RKYPOOFRING)

addHook("MobjThinker", function(mo)
	//print(abs(mo.momz))
	if (mo.zMomLog ~= nil)
	and (((abs(mo.momz)) > 0) and (mo.standingslope == nil))
		mo.zMomLog = (abs(mo.momz))
	end
	if (P_IsObjectOnGround(mo) or (mo.standingslope ~= nil))
	and (mo.zMomLog ~= nil)
	and (mo.zMomLog > 2*mo.scale)
		mo.momz = ((mo.zMomLog*65)/100);
		S_StartSound(mo,sfx_rkrng)
	end
	A_AttractChase(mo)
end, MT_RKYPOOFRING)

addHook("PreThinkFrame", do
    for p in players.iterate
    do
        if (p.mo and p.mo.valid)
		and (not p.mo.logprevbuffer)
        then
            p.mo.premomx = p.mo.momx
            p.mo.premomy = p.mo.momy
        end
    end
end)

addHook("MobjCollide", function(tm, mo) // separating
	local mom_magnitude = R_PointToDist2(0,0,mo.momx,mo.momy)
	if (mo.player)
	and ((mo.player.punched) or (mo.player.kickType)) or ((mo.state == S_PLAY_SLID) or (mo.state == S_PLAY_SWEP))
	and (gametype == GT_COOP)
		if (not mo.valid) then return; end
		if (not tm.valid) then return; end
		
		/*local distcheck = true;
		
		local xydist = R_PointToDist2(p.mo.x,p.mo.y,mo.x,mo.y);
		
		if (R_PointToDist2(0,p.mo.z,xydist,mo.z) > (160*p.mo.scale))
			distcheck = false;
		end
		
		if (not distcheck) then continue; end*/
		
		if (not (mo.flags & MF_NOCLIPTHING))
			if tm.type == MT_SALOONDOORCENTER
				tm.flags = $|MF_NOCLIP
				P_InstaThrust(mo, InvAngle(mo.player.drawangle), 4*mo.scale)
			end
			tm.flags = $|MF_NOCLIP
			mo.flags = $|MF_NOCLIPTHING
			doCorkExplosion(tm)
			P_InstaThrust(mo, InvAngle(mo.player.drawangle), 4*mo.scale)
			P_KillMobj(tm, mo, MT_SALOONDOOR)
			mo.logprevbuffer = 2
			mo.momx = mo.premomx
			mo.momy = mo.premomy
			S_StartSound(mo, sfx_64brk)
			S_StartSound(mo, sfx_sgiwk)
			if (mo.flags & MF_NOCLIPTHING)
				mo.flags = ($ & ~MF_NOCLIPTHING)
			end
		end
	end
end, MT_SALOONDOORCENTER)

addHook("MobjCollide", function(tm, mo) // separating
	if (mo.z > (tm.z + tm.height + (4*tm.scale))) then return; end; // overhead
	if (mo.z + mo.height < (tm.z - (4*tm.scale))) then return; end // underneath
	
	if (mo.player)
	and ((mo.player.punched) or (mo.player.kickType)) or ((mo.state == S_PLAY_SLID) or (mo.state == S_PLAY_SWEP))
		if (not mo.valid) then return; end
		if (not tm.valid) then return; end
		
		if (tm.health)
			P_KillMobj(tm, mo, nil);
		end
	end
end, MT_SPIKE)

addHook("MobjThinker", function(mo)
	for p in players.iterate
	do
		if (not (p.mo and p.mo.valid)) then continue; end
		if (not p.rk_poundtime) then continue; end
		if (not p.powers[pw_super]) then continue; end
		if (not mo.valid) then continue; end
		
		local distcheck = true;
		
		local xydist = R_PointToDist2(p.mo.x,p.mo.y,mo.x,mo.y);
		
		if (R_PointToDist2(0,p.mo.z,xydist,mo.z) > (160*p.mo.scale))
			distcheck = false;
		end
		
		if (not distcheck) then continue; end
		
		if (mo.health)
			P_KillMobj(mo, p.mo, nil);
		end
	end
end, MT_SPIKE)

addHook("MobjCollide", function(tm, mo) // separating
	if (mo.z > (tm.z + tm.height + (4*tm.scale))) then return; end; // overhead
	if (mo.z + mo.height < (tm.z - (4*tm.scale))) then return; end // underneath
	
	if (mo.player)
	and ((mo.player.punched) or (mo.player.kickType)) or ((mo.state == S_PLAY_SLID) or (mo.state == S_PLAY_SWEP))
		if (not mo.valid) then return; end
		if (not tm.valid) then return; end
		
		if (tm.health)
			P_KillMobj(tm, mo, nil);
		end
	end
end, MT_WALLSPIKE)

addHook("MobjThinker", function(mo)
	for p in players.iterate
	do
		if (not (p.mo and p.mo.valid)) then continue; end
		if (not p.rk_poundtime) then continue; end
		if (not p.powers[pw_super]) then continue; end
		if (not mo.valid) then continue; end
		
		local distcheck = true;
		
		local xydist = R_PointToDist2(p.mo.x,p.mo.y,mo.x,mo.y);
		
		if (R_PointToDist2(0,p.mo.z,xydist,mo.z) > (160*p.mo.scale))
			distcheck = false;
		end
		
		if (not distcheck) then continue; end
		
		if (mo.health)
			P_KillMobj(mo, p.mo, nil);
		end
	end
end, MT_WALLSPIKE)

local function P_CheckMobjAndToucherZ(mo, tm, tmheightoffset, checktmfloor)
    if (checktmfloor == nil) then
		checktmfloor = false;
	end
	
	if (tm.z > (mo.z + mo.height)) then
        return false;
    end

    if (mo.z - mo.height > (tm.z + (tm.height - tmheightoffset))) then
        return false;
    end
	
	if (checktmfloor) then
		if (mo.z > (tm.z + (tm.height - tmheightoffset))) then
			return false;
		end
	end

    return true;
end

addHook("MobjMoveCollide", function(mo, tm)
	if not (tm.flags & MF_PUSHABLE) then return end
	--print(tm.flags & MF_PUSHABLE)
	if P_CheckMobjAndToucherZ(mo, tm, 3 * mo.scale / 2, true) then
		if P_IsObjectOnGround(mo)
			if (mo.player.shovetimer ~= nil)
				mo.player.shovetimer = min(8,$+6)
			else
				mo.player.shovetimer = 6
			end
		end
	end
	--mo.player.shovetimer = max(0,$-1)
end, MT_PLAYER)

// battlemod kicks
addHook("MobjDamage", function(mo, i, src)
	if (mo and mo.valid and (mo.health) and mo.player and i and (i.valid) and (i == src) and (i.health) and i.player and i.skin == "sgimario")
	and (CBW_Battle)
	and (isBattleMod())
		local p = i.player
		if ((p.kickType) and (p.punched == false))
			P_SetObjectMomZ(mo, 15*mo.scale, false)
			P_InstaThrust(mo, i.player.drawangle, 16*mo.scale)
			
			mo.kickedBy64 = true
			mo.gotKickedAng = i.angle
			mo.kickDmgTimer = 4
			
			p.mo.momx = -16*cos(p.drawangle);
			p.mo.momy = -16*sin(p.drawangle);
			
			S_StartSound(nil, sfx_sgiwk, i.player);
			S_StartSound(mo, sfx_sgiwk);
			doKickStars(mo);
			P_StartQuake(FRACUNIT*3, 10);
		elseif (p.punched == true)
			//print("punched"); -- placeholders
		end
	end
end)

addHook("PlayerThink", function(p)
	if (not (p.mo and p.mo.valid)) then return; end
	if (p.shovetimer ~= nil) then
		p.shovetimer = max(0,$-1)
		--print(p.shovetimer)
	end
	
	if (p.mo.kickedBy64 ~= nil)
		if (p.mo.kickDmgTimer ~= nil)
		and (p.mo.kickDmgTimer > 0)
			//print("got kicked")
			P_SetObjectMomZ(p.mo, 15*p.mo.scale, false) // kick damage is aggressive
			P_InstaThrust(p.mo, p.mo.gotKickedAng, 8*p.mo.scale)
			p.mo.kickDmgTimer = $1 - 1;
		else
			p.mo.kickedBy64 = nil
			p.mo.kickDmgTimer = nil
		end
	end
end)

addHook("MobjDeath", function(mo, i, src)
//if not (mo and mo.valid and i and i.valid and i.health and i.player) then return end;
	if (mo and mo.valid and (mo.flags & MF_ENEMY) and i and (i.valid) and (i == src) and (i.health) and i.player and i.skin == "sgimario")
		local p = i.player;
		mo.tics = -1
		//pMo = p.mo;
		S_StopSound(mo)
		if (p.punched == true)
			mo.flags2 = $|MF2_DONTDRAW
		end
		
		//if p and pMo.skin == "sgimario"
			//print("bing bing")
			// noooo moooore sigsegs! *vine thud*
			S_StopSound(mo)
			local ds = states[mo.info.deathstate]
			// if not (ds.tics) then return end // punches stop working if I re-enable this
			if not (ds.action) then return end
			if ((ds.action ~= A_FlickySpawn) and (mo.sprite ~= SPR_GOOM) and (mo.sprite ~= SPR_BGOM)) 
				bouncePlayerBackFromAttack(p)
				return
			end
			if ((p.punched == true) and not (p.powers[pw_super] or p.powers[pw_invulnerability])) // kicking myself because the object was detecting it was on the goddamn ground; keeping this in anyways just in case
				mo.flags2 = $|MF2_DONTDRAW
				local punch = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+10*mo.scale, MT_RKYKICKEDENEMY)
				punch.sprite = mo.sprite;
				punch.deathTimeout = (1*TICRATE)/2;
				punch.angle = mo.angle;
				punch.shadowscale = FRACUNIT;
				if (mo.sprite == SPR_GOOM) or (mo.sprite == SPR_BGOM)
					punch.wasGoomba = true
				end
				P_SetObjectMomZ(punch, ((750*mo.scale)/100), false)
				P_InstaThrust(punch, p.drawangle, 16*mo.scale)
				if (mo.sprite == SPR_CRAB)
					if ((mo.tracer) and (mo.tracer.valid))
						//local mo2 = mo.tracer.target
						local spinClaw = P_SpawnMobj(mo.tracer.x, mo.tracer.y, mo.tracer.z, MT_RKYKICKEDEXTRA)
						
						spinClaw.sprite = mo.tracer.sprite;
						spinClaw.frame = 3;
							
						local rngAngle = P_RandomRange(0,360)
						spinClaw.momx = 12*cos(rngAngle*ANG1);
						spinClaw.momy = 12*sin(rngAngle*ANG1);
						spinClaw.momz = ((750*mo.scale)/100);
						spinClaw.angle = mo.tracer.angle;
						
						local crabTarget = mo.tracer.target;
							
						while (crabTarget)
							local tgNext = crabTarget.target
							local spinChain = P_SpawnMobj(crabTarget.x, crabTarget.y, crabTarget.z, MT_RKYKICKEDEXTRA)
							local rngAngle2 = P_RandomRange(0,360)
							
							spinChain.sprite = crabTarget.sprite;
							spinChain.frame = 4;
							
							spinChain.momx = 12*cos(rngAngle2*ANG1);
							spinChain.momy = 12*sin(rngAngle2*ANG1);
							spinChain.momz = ((750*mo.scale)/200);
							crabTarget.state = S_NULL
							crabTarget = tgNext;
						end
								
						mo.tracer.state = S_NULL
					end
				end
				bouncePlayerBackFromAttack(p)
			end
			if (((p.kickType) and (p.punched == false))
			and (p.mo.state ~= S_PLAY_KCFL))
			or (p.powers[pw_super] or p.powers[pw_invulnerability] or p.mo.state == S_PLAY_SLID or p.mo.state == S_PLAY_SWEP)
				if ((ds.action == A_FlickySpawn) or (mo.sprite == SPR_GOOM) or (mo.sprite == SPR_BGOM))
				//and (p.powers[pw_flashing] < 1)
				//and (mo.standingslope == nil)
					if (p.powers[pw_invulnerability])
						S_StartSound(mo, sfx_sgiwk);
						
						if (p.starcombo ~= nil)
							p.starcombo = $ + 1;
							
							if (p.starcombo >= 8)
								if (not ultimatemode)
									P_GiveCoopLives(p, 1, false); // 1-up, baybee!
									S_StartSound(nil, sfx_641up, p);
								end
							end
						else
							p.starcombo = 1;
						end
						
						local num = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK);
						
						num.scale = p.mo.scale;
						num.momz = 9*p.mo.scale;
						num.tics = -1;
						num.fuse = -1;
						num.sprite = SPR_RKSN;
						num.frame = ((p.starcombo) and min(p.starcombo, 8) or 1)|FF_FULLBRIGHT;
						
						if (num.flags & MF_NOGRAVITY)
							num.flags = ($ & ~MF_NOGRAVITY)
						end
						
						
					end
					
					local tx = 15*cos(p.mo.angle);
					local ty = 15*sin(p.mo.angle);
					mo.flags2 = $|MF2_DONTDRAW
					local test = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+((p.powers[pw_super] or p.powers[pw_invulnerability] or p.mo.state == S_PLAY_SLID or p.mo.state == S_PLAY_SWEP) and (p.mo.height*P_MobjFlip(p.mo)) or 0), MT_RKYKICKEDENEMY)
					if (mo.sprite == SPR_GOOM) or (mo.sprite == SPR_BGOM)
						test.wasGoomba = true
					end
					test.shadowscale = FRACUNIT;
					test.sprite = mo.sprite;
					test.deathTimeout = (1*TICRATE)/2;
					test.angle = mo.angle;
					//print(mo.spritexscale);
					test.spritexscale = (mo.spritexscale/2)
					test.spriteyscale = ((mo.spriteyscale*250)/100)
					test.kickedFx = true;
					doKickStars(test)
					//test.info.deathstate = p.kickedMoDeath;
					//test.momx = 16*cos(p.mo.angle);
					//test.momy = 16*sin(p.mo.angle);
					//test.momz = 15*mo.scale;
					
					P_SetObjectMomZ(test, 15*mo.scale, false)
					P_InstaThrust(test, p.drawangle, 16*mo.scale)
					if (mo.sprite == SPR_CRAB)
						if ((mo.tracer) and (mo.tracer.valid))
							//local mo2 = mo.tracer.target
							local spinClaw = P_SpawnMobj(mo.tracer.x, mo.tracer.y, mo.tracer.z, MT_RKYKICKEDEXTRA)
							
							spinClaw.sprite = mo.tracer.sprite;
							spinClaw.frame = 3;
								
							local rngAngle = P_RandomRange(0,360)
							spinClaw.momx = 12*cos(rngAngle*ANG1);
							spinClaw.momy = 12*sin(rngAngle*ANG1);
							spinClaw.momz = ((750*mo.scale)/100);
							spinClaw.angle = mo.tracer.angle;
							
							local crabTarget = mo.tracer.target;
								
							while (crabTarget)
								local tgNext = crabTarget.target
								local spinChain = P_SpawnMobj(crabTarget.x, crabTarget.y, crabTarget.z, MT_RKYKICKEDEXTRA)
								local rngAngle2 = P_RandomRange(0,360)
								
								spinChain.sprite = crabTarget.sprite;
								spinChain.frame = 4;
								
								spinChain.momx = 12*cos(rngAngle2*ANG1);
								spinChain.momy = 12*sin(rngAngle2*ANG1);
								spinChain.momz = ((750*mo.scale)/200);
								crabTarget.state = S_NULL
								crabTarget = tgNext;
							end
								
							mo.tracer.state = S_NULL
						end
					end
					bounceBackFromAttack(p)
				end
			else
				bounceBackFromAttack(p)
			end
		//end
	elseif (mo and mo.valid and i and (i.valid) and (i == src) and (i.health) and i.player and i.skin == "sgimario")
		local p = i.player;
		if (mo.flags & MF_BOSS)
			p.bossClear = 1
		end
		bouncePlayerBackFromAttack(p)
	end
end)