rawset(_G, "P_RingThinker", function(mobj)
	if (mobj.momx or mobj.momy)
	then
		P_RingXYMovement(mobj);
		if (not mobj.valid) then return; end
    end

	-- always do the gravity bit now, that's simpler
	-- BUT CheckPosition only if wasn't done before.
	if (mobj.momz)
	then
		P_RingZMovement(mobj);
		P_CheckPosition(mobj, mobj.x, mobj.y); -- Need this to pick up objects!
		if (not mobj.valid) then return; end
    end
end)

rawset(_G, "P_NightsItemChase", function(thing)
	if (not thing.tracer)
	then
		thing.tracer = nil;
		thing.flags2 = ($ & ~MF2_NIGHTSPULL);
		thing.movefactor = 0;
		return;
    end

	if (not thing.tracer.player) then return; end

	P_Attract(thing, thing.tracer, true, false);
end)


rawset(_G, "P_RingMobjThinker", function(mobj)
    -- No need to check water. Who cares?
	P_RingThinker(mobj);
	if (mobj.flags2 & MF2_NIGHTSPULL)
    then
		P_NightsItemChase(mobj);
	elseif (mobj.type ~= MT_BOMBSPHERE) -- prevent shields from attracting bomb spheres
    then
		A_AttractChase(mobj);
    end
	return false;
end)