-- comedy of the HUD variety

local function rkyHealthHud(v, p)
	local screen_width = (v.width() / v.dupx());
	local screen_xcenter = ((screen_width - (screen_width - 320))/2);

    local phealth = 9 - max(0, ((p.rkyHealth ~= nil) and (p.rkyHealth/272) or 8));
    phealth = min($, 9);
	if ((p.playerstate == PST_DEAD) or p.rk_deadtime)
	and phealth == 1
		phealth = 9; 
	end
	local ultmodecheck = (ultimatemode and (p.mo and p.mo.valid) and (not (p.mo.eflags & MFE_UNDERWATER)) and (p.playerstate ~= PST_DEAD));
    
    if not (splitscreen) then v.draw(screen_xcenter, 0 + min(32, ((p.rky_damagetime) and p.rky_damagetime or 0)) - min(64, (max(0, ((p.rky_maxhtime) and (p.rky_maxhtime-(TICRATE*2)) or 0))*4)), ((ultmodecheck) and v.cachePatch("RKUMP") or v.cachePatch("RKPW"..phealth)), V_HUDTRANS|V_SNAPTOTOP);
	elseif (splitscreen) then v.draw(screen_xcenter, 0, ((ultmodecheck) and v.cachePatch("RKUMP") or v.cachePatch("RKPW"..phealth)), V_HUDTRANS|V_SNAPTOTOP|V_PERPLAYER); 
	end
end


local function n64MarioHud(v, p)
    if (p.mo and p.mo.valid and p.mo.skin == "sgimario" and (not (p.nightstime or p.rk_dontusehealth)))
		rkyHealthHud(v, p);
	end
end

hud.add(n64MarioHud, game)