local function P_IsLocalPlayer(player)
	return ((splitscreen and player == secondarydisplayplayer) or player == consoleplayer);
end

rawset(_G, "P_DoMetalTransformation", function(p, giverings)
	if (not All7Emeralds(emeralds)) then return; end
	
	p.metalmode2 = true;
	if (not (p.charflags & SF_SUPER))
		p.charflags = $|SF_SUPER;
		//print("THE SUPER MARIO BROS. SUPER SHOW");
	end
	
	p.powers[pw_super] = 1;
	if ((not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC)) and P_IsLocalPlayer(p))
		P_PlayJingle(p, JT_SUPER);
    end

	S_StartSound(nil, sfx_supert); -- let all players hear it -mattw_cfi

	p.mo.momx, p.mo.momy, p.mo.momz, p.cmomx, p.cmomy, p.rmomx, p.rmomy = 0, 0, 0, 0, 0, 0, 0;

	-- Transformation animation
	p.mo.state = S_PLAY_SUPER_TRANS1;

	if (giverings and p.rings < 50)
		p.rings = 50;
    end

	-- Just in case.
	if (not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC))
		p.powers[pw_extralife] = 0;
		p.powers[pw_invulnerability] = 0;
		p.powers[pw_sneakers] = 0;
	end
	
	

	P_PlayerFlagBurst(p, false);
end)
